OpenTTD Source: NetworkContentListWindow Class Reference

OpenTTD Source 15.0-beta1

Public Member Functions | Private Types | Private Member Functions | Static Private Member Functions | Private Attributes | Static Private Attributes | Friends
NetworkContentListWindow Class Reference

Window that lists the content that's at the content server. More...

Inheritance diagram for NetworkContentListWindow:

## Public Member Functions
| NetworkContentListWindow (WindowDesc &desc, bool select_all, const std::bitset< CONTENT_TYPE_END > &types)
| Create the content list window.
void | Close (int data=0) override
| Hide the window and all its child windows, and mark them for a later deletion.
void | OnInit () override
| Notification that the nested widget tree gets initialized.
void | UpdateWidgetSize (WidgetID widget, Dimension &size, const Dimension &padding, Dimension &fill, Dimension &resize) override
| Update size and resize step of a widget in the window.
void | DrawWidget (const Rect &r, WidgetID widget) const override
| Draw the contents of a nested widget.
void | OnPaint () override
| The window must be repainted.
void | DrawMatrix (const Rect &r) const
| Draw/fill the matrix with the list of content to download.
void | DrawDetails (const Rect &r) const
| Helper function to draw the details part of this window.
void | OnClick (Point pt, WidgetID widget, int click_count) override
| A click with the left mouse button has been made on the window.
EventState | OnKeyPress (char32_t key, uint16_t keycode) override
| A key has been pressed.
void | OnEditboxChanged (WidgetID wid) override
| The text in an editbox has been edited.
void | OnResize () override
| Called after the window got resized.
void | OnReceiveContentInfo (const ContentInfo *rci) override
| We received a content info.
void | OnDownloadComplete (ContentID) override
| We have finished downloading a file.
void | OnConnect (bool success) override
| Callback for when the connection has finished.
void | OnInvalidateData (int data=0, bool gui_scope=true) override
| Some data on this window has become invalid.
Public Member Functions inherited from Window
| Window (WindowDesc &desc)
| Empty constructor, initialization has been moved to InitNested() called from the constructor of the derived class.
void * | operator new[] (size_t size)=delete
| Helper allocation function to disallow something.
template<class NWID >
const NWID * | GetWidget (WidgetID widnum) const
| Get the nested widget with number widnum from the nested widget tree.
template<class NWID >
NWID * | GetWidget (WidgetID widnum)
| Get the nested widget with number widnum from the nested widget tree.
const Scrollbar * | GetScrollbar (WidgetID widnum) const
| Return the Scrollbar to a widget index.
Scrollbar * | GetScrollbar (WidgetID widnum)
| Return the Scrollbar to a widget index.
const QueryString * | GetQueryString (WidgetID widnum) const
| Return the querystring associated to a editbox.
QueryString * | GetQueryString (WidgetID widnum)
| Return the querystring associated to a editbox.
void | UpdateQueryStringSize ()
| Update size of all QueryStrings of this window.
virtual const struct Textbuf * | GetFocusedTextbuf () const
| Get the current input text buffer.
virtual Point | GetCaretPosition () const
| Get the current caret position if an edit box has the focus.
virtual Rect | GetTextBoundingRect (const char *from, const char *to) const
| Get the bounding rectangle for a text range if an edit box has the focus.
virtual ptrdiff_t | GetTextCharacterAtPosition (const Point &pt) const
| Get the character that is rendered at a position by the focused edit box.
void | InitNested (WindowNumber number=0)
| Perform complete initialization of the Window with nested widgets, to allow use.
void | CreateNestedTree ()
| Perform the first part of the initialization of a nested widget tree.
void | FinishInitNested (WindowNumber window_number=0)
| Perform the second part of the initialization of a nested widget tree.
template<typename T , std::enable_if_t< std::is_base_of< StrongTypedefBase, T >::value, int > = 0>
void | FinishInitNested (T number)
void | SetTimeout ()
| Set the timeout flag of the window and initiate the timer.
void | SetWhiteBorder ()
| Set the timeout flag of the window and initiate the timer.
void | DisableAllWidgetHighlight ()
| Disable the highlighted status of all widgets.
void | SetWidgetHighlight (WidgetID widget_index, TextColour highlighted_colour)
| Sets the highlighted status of a widget.
bool | IsWidgetHighlighted (WidgetID widget_index) const
| Gets the highlighted status of a widget.
void | SetWidgetDisabledState (WidgetID widget_index, bool disab_stat)
| Sets the enabled/disabled status of a widget.
void | DisableWidget (WidgetID widget_index)
| Sets a widget to disabled.
void | EnableWidget (WidgetID widget_index)
| Sets a widget to Enabled.
bool | IsWidgetDisabled (WidgetID widget_index) const
| Gets the enabled/disabled status of a widget.
bool | IsWidgetFocused (WidgetID widget_index) const
| Check if given widget is focused within this window.
bool | IsWidgetGloballyFocused (WidgetID widget_index) const
| Check if given widget has user input focus.
void | SetWidgetLoweredState (WidgetID widget_index, bool lowered_stat)
| Sets the lowered/raised status of a widget.
void | ToggleWidgetLoweredState (WidgetID widget_index)
| Invert the lowered/raised status of a widget.
void | LowerWidget (WidgetID widget_index)
| Marks a widget as lowered.
void | RaiseWidget (WidgetID widget_index)
| Marks a widget as raised.
void | RaiseWidgetWhenLowered (WidgetID widget_index)
| Marks a widget as raised and dirty (redraw), when it is marked as lowered.
bool | IsWidgetLowered (WidgetID widget_index) const
| Gets the lowered state of a widget.
void | UnfocusFocusedWidget ()
| Makes no widget on this window have focus.
bool | SetFocusedWidget (WidgetID widget_index)
| Set focus within this window to the given widget.
EventState | HandleEditBoxKey (WidgetID wid, char32_t key, uint16_t keycode)
| Process keypress for editbox widget.
virtual void | InsertTextString (WidgetID wid, const char *str, bool marked, const char *caret, const char *insert_location, const char *replacement_end)
| Insert a text string at the cursor position into the edit box widget.
void | HandleButtonClick (WidgetID widget)
| Do all things to make a button look clicked and mark it to be unclicked in a few ticks.
int | GetRowFromWidget (int clickpos, WidgetID widget, int padding, int line_height=-1) const
| Compute the row of a widget that a user clicked in.
void | RaiseButtons (bool autoraise=false)
| Raise the buttons of the window.
template<typename... Args>
void | SetWidgetsDisabledState (bool disab_stat, Args... widgets)
| Sets the enabled/disabled status of a list of widgets.
template<typename... Args>
void | SetWidgetsLoweredState (bool lowered_stat, Args... widgets)
| Sets the lowered/raised status of a list of widgets.
template<typename... Args>
void | RaiseWidgetsWhenLowered (Args... widgets)
| Raises the widgets and sets widgets dirty that are lowered.
void | SetWidgetDirty (WidgetID widget_index) const
| Invalidate a widget, i.e.
void | DrawWidgets () const
| Paint all widgets of a window.
void | DrawViewport () const
| Draw the viewport of this window.
void | DrawSortButtonState (WidgetID widget, SortButtonState state) const
| Draw a sort button's up or down arrow symbol.
Window * | FindChildWindow (WindowClass wc=WC_INVALID) const
| Find the Window whose parent pointer points to this window.
void | CloseChildWindows (WindowClass wc=WC_INVALID) const
| Close all children a window might have in a head-recursive manner.
void | SetDirty () const
| Mark entire window as dirty (in need of re-paint)
void | ReInit (int rx=0, int ry=0, bool reposition=false)
| Re-initialize a window, and optionally change its size.
bool | IsShaded () const
| Is window shaded currently?
void | SetShaded (bool make_shaded)
| Set the shaded state of the window to make_shaded.
void | ScheduleResize ()
| Mark this window as resized and in need of OnResize() event.
void | ProcessScheduledResize ()
| Process scheduled OnResize() event.
void | InvalidateData (int data=0, bool gui_scope=true)
| Mark this window's data as invalid (in need of re-computing)
void | ProcessScheduledInvalidations ()
| Process all scheduled invalidations.
void | ProcessHighlightedInvalidations ()
| Process all invalidation of highlighted widgets.
virtual void | ApplyDefaults ()
| Read default values from WindowDesc configuration an apply them to the window.
virtual Point | OnInitialPosition (int16_t sm_width, int16_t sm_height, int window_number)
| Compute the initial position of the window.
virtual void | SetStringParameters (WidgetID widget) const
| Initialize string parameters for a widget.
virtual void | OnFocus ()
| The window has gained focus.
virtual void | OnFocusLost (bool closing)
| The window has lost focus.
virtual EventState | OnHotkey (int hotkey)
| A hotkey has been pressed.
virtual EventState | OnCTRLStateChange ()
| The state of the control key has changed.
virtual bool | OnRightClick (Point pt, WidgetID widget)
| A click with the right mouse button has been made on the window.
virtual void | OnHover (Point pt, WidgetID widget)
| The mouse is hovering over a widget in the window, perform an action for it.
virtual bool | OnTooltip (Point pt, WidgetID widget, TooltipCloseCondition close_cond)
| Event to display a custom tooltip.
virtual void | OnMouseDrag (Point pt, WidgetID widget)
| An 'object' is being dragged at the provided position, highlight the target if possible.
virtual void | OnDragDrop (Point pt, WidgetID widget)
| A dragged 'object' has been released.
virtual void | OnScroll (Point delta)
| Handle the request for (viewport) scrolling.
virtual void | OnMouseOver (Point pt, WidgetID widget)
| The mouse is currently moving over the window or has just moved outside of the window.
virtual void | OnMouseWheel (int wheel)
| The mouse wheel has been turned.
virtual void | OnMouseLoop ()
| Called for every mouse loop run, which is at least once per (game) tick.
virtual void | OnGameTick ()
| Called once per (game) tick.
virtual void | OnRealtimeTick (uint delta_ms)
| Called periodically.
virtual void | OnTimeout ()
| Called when this window's timeout has been reached.
virtual void | OnDropdownSelect (WidgetID widget, int index)
| A dropdown option associated to this window has been selected.
virtual void | OnDropdownClose (Point pt, WidgetID widget, int index, bool instant_close)
| A dropdown window associated to this window has been closed.
virtual void | OnQueryTextFinished (std::optional< std::string > str)
| The query window opened from this window has closed.
virtual void | OnPlaceObject (Point pt, TileIndex tile)
| The user clicked some place on the map when a tile highlight mode has been set.
virtual bool | OnVehicleSelect (const struct Vehicle *v)
| The user clicked on a vehicle while HT_VEHICLE has been set.
virtual bool | OnVehicleSelect (VehicleList::const_iterator begin, VehicleList::const_iterator end)
| The user clicked on a vehicle while HT_VEHICLE has been set.
virtual void | OnPlaceObjectAbort ()
| The user cancelled a tile highlight mode that has been set.
virtual void | OnPlaceDrag (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt)
| The user is dragging over the map when the tile highlight mode has been set.
virtual void | OnPlaceMouseUp (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt, TileIndex start_tile, TileIndex end_tile)
| The user has dragged over the map when the tile highlight mode has been set.
virtual void | OnPlacePresize (Point pt, TileIndex tile)
| The user moves over the map when a tile highlight mode has been set when the special mouse mode has been set to 'PRESIZE' mode.
virtual bool | IsNewGRFInspectable () const
| Is the data related to this window NewGRF inspectable?
virtual void | ShowNewGRFInspectWindow () const
| Show the NewGRF inspection window.
template<>
const NWidgetBase * | GetWidget (WidgetID widnum) const
| Specialized case of Window::GetWidget for the nested widget base class.
Public Member Functions inherited from ZeroedMemoryAllocator
void * | operator new (size_t size)
| Memory allocator for a single class instance.
void * | operator new[] (size_t size)
| Memory allocator for an array of class instances.
void | operator delete (void *ptr)
| Memory release for a single class instance.
void | operator delete[] (void *ptr)
| Memory release for an array of class instances.

## Private Types
typedef GUIList< const ContentInfo *, std::nullptr_t, ContentListFilterData & > | GUIContentList
| List with content infos.

## Private Member Functions
void | OpenExternalSearch ()
| Search external websites for content.
void | BuildContentList ()
| (Re)build the network game list as its amount has changed because an item has been added or deleted for example
void | SortContentList ()
| Sort the content list.
void | FilterContentList ()
| Filter the content list.
bool | UpdateFilterState ()
| Update filter state based on current window state.
void | ScrollToSelected ()
| Make sure that the currently selected content info is within the visible part of the matrix.
Private Member Functions inherited from ContentCallback
virtual void | OnDisconnect ()
| Callback for when the connection got disconnected.
virtual void | OnDownloadProgress (const ContentInfo *ci, int bytes)
| We have progress in the download of a file.
virtual | ~ContentCallback ()=default
| Silentium.

## Static Private Member Functions
static void | ExternalSearchDisclaimerCallback (Window *w, bool accepted)
| Callback function for disclaimer about entering external websites.
static bool | NameSorter (const ContentInfo *const &a, const ContentInfo *const &b)
| Sort content by name.
static bool | TypeSorter (const ContentInfo *const &a, const ContentInfo *const &b)
| Sort content by type.
static bool | StateSorter (const ContentInfo *const &a, const ContentInfo *const &b)
| Sort content by state.
static bool | TagNameFilter (const ContentInfo *const *a, ContentListFilterData &filter)
| Filter content by tags/name.
static bool | TypeOrSelectedFilter (const ContentInfo *const *a, ContentListFilterData &filter)
| Filter content by type, but still show content selected for download.

## Private Attributes
GUIContentList | content
| List with content.
bool | auto_select
| Automatically select all content when the meta-data becomes available.
ContentListFilterData | filter_data
| Filter for content list.
QueryString | filter_editbox
| Filter editbox;.
Dimension | checkbox_size
| Size of checkbox/"blot" sprite.
const ContentInfo * | selected
| The selected content info.
int | list_pos
| Our position in the list.
uint | filesize_sum
| The sum of all selected file sizes.
Scrollbar * | vscroll
| Cache of the vertical scrollbar.

## Static Private Attributes
static const uint | EDITBOX_MAX_SIZE = 50
| Maximum size of the editbox in characters.
static Listing | last_sorting = {false, 1}
| The last sorting setting.
static Filtering | last_filtering = {false, 0}
| The last filtering setting.
static const std::initializer_list< GUIContentList::SortFunction *const > | sorter_funcs
| Sorter functions.
static const std::initializer_list< GUIContentList::FilterFunction *const > | filter_funcs
| Filter functions.
static std::string | content_type_strs [CONTENT_TYPE_END]
| Cached strings for all content types.

## Friends
void | BuildContentTypeStringList ()
| Build array of all strings corresponding to the content types.

## Additional Inherited Members
Public Types inherited from Window
using | IteratorToFront = WindowIterator< false >
| Iterate in Z order towards front.
using | IteratorToBack = WindowIterator< true >
| Iterate in Z order towards back.
using | Iterate = AllWindows< false >
| Iterate all windows in whatever order is easiest.
using | IterateFromBack = AllWindows< false >
| Iterate all windows in Z order from back to front.
using | IterateFromFront = AllWindows< true >
| Iterate all windows in Z order from front to back.
Static Public Member Functions inherited from Window
static int | SortButtonWidth ()
| Get width of up/down arrow of sort button state.
static void | DeleteClosedWindows ()
| Delete all closed windows.
Data Fields inherited from Window
WindowDesc & | window_desc
| Window description.
WindowFlags | flags
| Window flags.
WindowClass | window_class
| Window class.
WindowNumber | window_number
| Window number within the window class.
int | scale
| Scale of this window – used to determine how to resize.
uint8_t | timeout_timer
| Timer value of the WF_TIMEOUT for flags.
uint8_t | white_border_timer
| Timer value of the WF_WHITE_BORDER for flags.
int | left
| x position of left edge of the window
int | top
| y position of top edge of the window
int | width
| width of the window (number of pixels to the right in x direction)
int | height
| Height of the window (number of pixels down in y direction)
ResizeInfo | resize
| Resize information.
Owner | owner
| The owner of the content shown in this window. Company colour is acquired from this variable.
ViewportData * | viewport
| Pointer to viewport data, if present.
const NWidgetCore * | nested_focus
| Currently focused nested widget, or `nullptr` if no nested widget has focus.
std::map< WidgetID, QueryString * > | querystrings
| QueryString associated to WWT_EDITBOX widgets.
std::unique_ptr< NWidgetBase > | nested_root
| Root of the nested tree.
WidgetLookup | widget_lookup
| Indexed access to the nested widget tree. Do not access directly, use Window::GetWidget() instead.
NWidgetStacked * | shade_select
| Selection widget (NWID_SELECTION) to use for shading the window. If `nullptr`, window cannot shade.
Dimension | unshaded_size
| Last known unshaded size (only valid while shaded).
WidgetID | mouse_capture_widget
| ID of current mouse capture widget (e.g. dragged scrollbar). -1 if no widget has mouse capture.
Window * | parent
| Parent window.
WindowList::iterator | z_position
Protected Member Functions inherited from Window
void | InitializeData (WindowNumber window_number)
| Initializes the data (except the position and initial size) of a new Window.
void | InitializePositionSize (int x, int y, int min_width, int min_height)
| Set the position and smallest size of the window.
virtual void | FindWindowPlacementAndResize (int def_width, int def_height)
| Resize window towards the default size.
virtual | ~Window ()
| Remove window and all its child windows from the window stack.
Protected Attributes inherited from Window
std::vector< int > | scheduled_invalidation_data
| Data of scheduled OnInvalidateData() calls.
bool | scheduled_resize
| Set if window has been resized.

## Detailed Description

Window that lists the content that's at the content server.

Definition at line 329 of file network_content_gui.cpp.

## Member Typedef Documentation

## ◆ GUIContentList

typedef GUIList<const ContentInfo *, std::nullptr_t, ContentListFilterData &> NetworkContentListWindow::GUIContentList
| private

List with content infos.

Definition at line 331 of file network_content_gui.cpp.

## Constructor & Destructor Documentation

## ◆ NetworkContentListWindow()

NetworkContentListWindow::NetworkContentListWindow | ( | WindowDesc & | desc,
|  | bool | select_all,
|  | const std::bitset< CONTENT_TYPE_END > & | types
| ) |  |
| inline

Create the content list window.

Parameters

  desc | the window description to pass to Window's constructor.
  select_all | Whether the select all button is allowed or not.
  types | the main type of content to display or CONTENT_TYPE_END. When a type other than CONTENT_TYPE_END is given, dependencies of other types are only shown when content that depend on them are selected.

Definition at line 545 of file network_content_gui.cpp.

References _network_content_client, QueryString::ACTION_CLEAR, ClientNetworkContentSocketHandler::AddCallback(), QueryString::cancel_button, Window::CreateNestedTree(), filter_editbox, FilterContentList(), Window::FinishInitNested(), GUIList< T, P, F >::ForceRebuild(), Window::GetScrollbar(), Window::GetWidget(), Window::InvalidateData(), Window::querystrings, GUIList< T, P, F >::SetFilterFuncs(), GUIList< T, P, F >::SetFiltering(), Window::SetFocusedWidget(), GUIList< T, P, F >::SetListing(), GUIList< T, P, F >::SetSortFuncs(), Window::SetWidgetDisabledState(), SortContentList(), ContentListFilterData::types, UpdateFilterState(), WID_NCL_FILTER, WID_NCL_SCROLLBAR, WID_NCL_SEARCH_EXTERNAL, WID_NCL_SEL_ALL_UPDATE, and WN_NETWORK_WINDOW_CONTENT_LIST.

## Member Function Documentation

## ◆ BuildContentList()

void NetworkContentListWindow::BuildContentList | ( |  | ) |
| inlineprivate

(Re)build the network game list as its amount has changed because an item has been added or deleted for example

Definition at line 407 of file network_content_gui.cpp.

References _network_content_client, ClientNetworkContentSocketHandler::Begin(), ContentInfo::DOES_NOT_EXIST, ClientNetworkContentSocketHandler::End(), FilterContentList(), Window::GetWidget(), GUIList< T, P, F >::NeedRebuild(), GUIList< T, P, F >::RebuildDone(), ScrollToSelected(), Scrollbar::SetCount(), Window::SetWidgetDisabledState(), SortContentList(), and WID_NCL_SEARCH_EXTERNAL.

Referenced by OnInvalidateData(), and OnPaint().

## ◆ Close()

void NetworkContentListWindow::Close | ( | int | data = `0` | ) |
| inlineoverridevirtual

Hide the window and all its child windows, and mark them for a later deletion.

Reimplemented from Window.

Definition at line 576 of file network_content_gui.cpp.

References _network_content_client, Window::Close(), and ClientNetworkContentSocketHandler::RemoveCallback().

Referenced by OnClick(), and OnConnect().

## ◆ DrawDetails()

void NetworkContentListWindow::DrawDetails | ( | const Rect & | r | ) | const
| inline

Helper function to draw the details part of this window.

Parameters

  r | the rectangle to stay within while drawing

Definition at line 686 of file network_content_gui.cpp.

References _network_content_client, ClientNetworkContentSocketHandler::Begin(), WidgetDimensions::bevel, CONTENT_TYPE_BASE_GRAPHICS, ContentInfo::dependencies, ContentInfo::description, DrawString(), DrawStringMultiLine(), ClientNetworkContentSocketHandler::End(), ContentInfo::filesize, WidgetDimensions::frametext, FS_NORMAL, GetCharacterHeight(), GetListSeparator(), Window::GetWidget(), GfxFillRect(), ContentInfo::id, ContentInfo::IsSelected(), ContentInfo::name, PC_DARK_BLUE, ClientNetworkContentSocketHandler::ReverseLookupTreeDependency(), SA_CENTER, SA_HOR_CENTER, WidgetDimensions::scaled, ContentInfo::SELECTED, SetDParam(), SetDParamStr(), Rect::Shrink(), ContentInfo::state, ContentInfo::tags, ContentInfo::type, ContentInfo::upgrade, ContentInfo::url, ContentInfo::version, RectPadding::Vertical(), WidgetDimensions::vsep_wide, and Rect::WithHeight().

Referenced by DrawWidget().

## ◆ DrawMatrix()

void NetworkContentListWindow::DrawMatrix | ( | const Rect & | r | ) | const
| inline

Draw/fill the matrix with the list of content to download.

Parameters

  r | The boundaries of the matrix.

Definition at line 645 of file network_content_gui.cpp.

References ContentInfo::ALREADY_HERE, ContentInfo::AUTOSELECTED, WidgetDimensions::bevel, CONTENT_TYPE_BASE_GRAPHICS, ContentInfo::DOES_NOT_EXIST, DrawString(), FS_NORMAL, GetCharacterHeight(), Scrollbar::GetVisibleRangeIterators(), Window::GetWidget(), GfxFillRect(), WidgetDimensions::matrix, ContentInfo::name, PC_GREY, SA_CENTER, SA_HOR_CENTER, WidgetDimensions::scaled, ContentInfo::SELECTED, Rect::Shrink(), ContentInfo::state, ContentInfo::type, ContentInfo::UNSELECTED, RectPadding::Vertical(), WID_NCL_CHECKBOX, WID_NCL_MATRIX, WID_NCL_NAME, WID_NCL_TYPE, and Rect::WithHeight().

Referenced by DrawWidget().

## ◆ DrawWidget()

void NetworkContentListWindow::DrawWidget | ( | const Rect & | r,
|  | WidgetID | widget
| ) |  | const
| inlineoverridevirtual

Draw the contents of a nested widget.

Parameters

  r | Rectangle occupied by the widget.
  widget | Number of the widget to draw.

Note
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 611 of file network_content_gui.cpp.

References DrawDetails(), DrawMatrix(), WID_NCL_DETAILS, and WID_NCL_MATRIX.

## ◆ ExternalSearchDisclaimerCallback()

static void NetworkContentListWindow::ExternalSearchDisclaimerCallback | ( | Window * | w,
|  | bool | accepted
| ) |  |
| inlinestaticprivate

Callback function for disclaimer about entering external websites.

Definition at line 395 of file network_content_gui.cpp.

References _accepted_external_search.

Referenced by OnClick().

## ◆ FilterContentList()

void NetworkContentListWindow::FilterContentList | ( |  | ) |
| inlineprivate

Filter the content list.

Definition at line 486 of file network_content_gui.cpp.

References CONTENT_FILTER_TEXT, CONTENT_FILTER_TYPE_OR_SELECTED, GUIList< T, P, F >::Filter(), find_index(), Window::GetWidget(), StringFilter::IsEmpty(), GUIList< T, P, F >::SetFilterType(), ContentListFilterData::string_filter, and ContentListFilterData::types.

Referenced by BuildContentList(), and NetworkContentListWindow().

## ◆ NameSorter()

static bool NetworkContentListWindow::NameSorter | ( | const ContentInfo *const & | a,
|  | const ContentInfo *const & | b
| ) |  |
| inlinestaticprivate

Sort content by name.

Definition at line 432 of file network_content_gui.cpp.

References ContentInfo::name, and StrNaturalCompare().

Referenced by TypeSorter().

## ◆ OnClick()

void NetworkContentListWindow::OnClick | ( | Point | pt,
|  | WidgetID | widget,
|  | int | click_count
| ) |  |
| inlineoverridevirtual

A click with the left mouse button has been made on the window.

Parameters

  pt | the point inside the window that has been clicked.
  widget | the clicked widget.
  click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 792 of file network_content_gui.cpp.

References _accepted_external_search, _network_content_client, ContentInfo::ALREADY_HERE, BringWindowToFrontById(), Close(), ExternalSearchDisclaimerCallback(), GUIList< T, P, F >::ForceRebuild(), GUIList< T, P, F >::ForceResort(), Scrollbar::GetScrolledItemFromWidget(), Window::GetWidget(), Window::InvalidateData(), IsInsideBS(), OpenExternalSearch(), ScrollToSelected(), ClientNetworkContentSocketHandler::SelectAll(), ClientNetworkContentSocketHandler::SelectUpgrade(), GUIList< T, P, F >::SetSortType(), ShowQuery(), SortContentList(), GUIList< T, P, F >::SortType(), ContentInfo::state, ClientNetworkContentSocketHandler::ToggleSelectedState(), GUIList< T, P, F >::ToggleSortOrder(), ContentListFilterData::types, ClientNetworkContentSocketHandler::UnselectAll(), ContentInfo::url, WC_NETWORK_STATUS_WINDOW, WID_NCL_CANCEL, WID_NCL_CHECKBOX, WID_NCL_DOWNLOAD, WID_NCL_MATRIX, WID_NCL_NAME, WID_NCL_OPEN_URL, WID_NCL_SEARCH_EXTERNAL, WID_NCL_SELECT_ALL, WID_NCL_SELECT_UPDATE, WID_NCL_TEXTFILE, WID_NCL_TYPE, WID_NCL_UNSELECT, and WN_NETWORK_STATUS_WINDOW_CONTENT_DOWNLOAD.

## ◆ OnConnect()

void NetworkContentListWindow::OnConnect | ( | bool | success | ) |
| inlineoverridevirtual

Callback for when the connection has finished.

Parameters

  success | whether the connection was made or that we failed to make it

Reimplemented from ContentCallback.

Definition at line 954 of file network_content_gui.cpp.

References Close(), Window::GetWidget(), INVALID_STRING_ID, Window::InvalidateData(), ShowErrorMessage(), and WL_ERROR.

## ◆ OnDownloadComplete()

void NetworkContentListWindow::OnDownloadComplete | ( | ContentID | cid | ) |
| inlineoverridevirtual

We have finished downloading a file.

Parameters

  cid | the ContentID of the downloaded file

Reimplemented from ContentCallback.

Definition at line 948 of file network_content_gui.cpp.

References GUIList< T, P, F >::ForceResort(), and Window::InvalidateData().

## ◆ OnEditboxChanged()

void NetworkContentListWindow::OnEditboxChanged | ( | WidgetID | widget | ) |
| inlineoverridevirtual

The text in an editbox has been edited.

Parameters

  widget | The widget of the editbox.

Reimplemented from Window.

Definition at line 926 of file network_content_gui.cpp.

References Textbuf::buf, GUIList< T, P, F >::ForceRebuild(), Window::GetWidget(), Window::InvalidateData(), StringFilter::SetFilterTerm(), ContentListFilterData::string_filter, UpdateFilterState(), and WID_NCL_FILTER.

## ◆ OnInit()

void NetworkContentListWindow::OnInit | ( |  | ) |
| inlineoverridevirtual

Notification that the nested widget tree gets initialized.

The event can be used to perform general computations.

Note
  nested_root and/or widget_lookup (normally accessed via GetWidget()) may not exist during this call.

Reimplemented from Window.

Definition at line 582 of file network_content_gui.cpp.

References GetScaledSpriteSize(), and maxdim().

## ◆ OnInvalidateData()

void NetworkContentListWindow::OnInvalidateData | ( | int | data = `0`,
|  | bool | gui_scope = `true`
| ) |  |
| inlineoverridevirtual

Some data on this window has become invalid.

Parameters

  data | Information about the changed data.
  gui_scope | Whether the call is done from GUI scope. You may not do everything when not in GUI scope. See InvalidateWindowData() for details.

Reimplemented from Window.

Definition at line 970 of file network_content_gui.cpp.

References ContentInfo::ALREADY_HERE, ContentInfo::AUTOSELECTED, BuildContentList(), content, ContentInfo::filesize, FindWindowById(), Window::GetWidget(), StringFilter::IsEmpty(), GUIList< T, P, F >::NeedRebuild(), ContentInfo::SELECTED, Window::SetWidgetDisabledState(), ContentInfo::state, ContentListFilterData::string_filter, ContentInfo::UNSELECTED, ContentInfo::upgrade, ContentInfo::url, WC_NETWORK_STATUS_WINDOW, WID_NCL_CANCEL, WID_NCL_DOWNLOAD, WID_NCL_OPEN_URL, WID_NCL_SELECT_ALL, WID_NCL_SELECT_UPDATE, WID_NCL_TEXTFILE, WID_NCL_UNSELECT, and WN_NETWORK_STATUS_WINDOW_CONTENT_DOWNLOAD.

## ◆ OnKeyPress()

EventState NetworkContentListWindow::OnKeyPress | ( | char32_t | key,
|  | uint16_t | keycode
| ) |  |
| inlineoverridevirtual

A key has been pressed.

Parameters

  key | the Unicode value of the key.
  keycode | the untranslated key code including shift state.

Returns
  ES_HANDLED if the key press has been handled and no other window should receive the event.

Reimplemented from Window.

Definition at line 878 of file network_content_gui.cpp.

References _network_content_client, ES_HANDLED, ES_NOT_HANDLED, GUIList< T, P, F >::ForceRebuild(), GUIList< T, P, F >::ForceResort(), Window::GetWidget(), Window::InvalidateData(), Window::IsWidgetFocused(), list_pos, ScrollToSelected(), ClientNetworkContentSocketHandler::ToggleSelectedState(), ContentListFilterData::types, UpdateFilterState(), Scrollbar::UpdateListPositionOnKeyPress(), and WID_NCL_FILTER.

## ◆ OnPaint()

void NetworkContentListWindow::OnPaint | ( |  | ) |
| inlineoverridevirtual

The window must be repainted.

Note
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 624 of file network_content_gui.cpp.

References BuildContentList(), Window::DrawSortButtonState(), Window::DrawWidgets(), Window::GetWidget(), GUIList< T, P, F >::IsDescSortOrder(), GUIList< T, P, F >::NeedRebuild(), SBS_DOWN, SBS_UP, GUIList< T, P, F >::SortType(), WID_NCL_CHECKBOX, WID_NCL_NAME, and WID_NCL_TYPE.

## ◆ OnReceiveContentInfo()

void NetworkContentListWindow::OnReceiveContentInfo | ( | const ContentInfo * | ci | ) |
| inlineoverridevirtual

We received a content info.

Parameters

  ci | the content info

Reimplemented from ContentCallback.

Definition at line 941 of file network_content_gui.cpp.

References _network_content_client, GUIList< T, P, F >::ForceRebuild(), Window::GetWidget(), Window::InvalidateData(), and ClientNetworkContentSocketHandler::ToggleSelectedState().

## ◆ OnResize()

void NetworkContentListWindow::OnResize | ( |  | ) |
| inlineoverridevirtual

Called after the window got resized.

For nested windows with a viewport, call NWidgetViewport::UpdateViewportCoordinates.

Reimplemented from Window.

Definition at line 936 of file network_content_gui.cpp.

References Scrollbar::SetCapacityFromWidget(), and WID_NCL_MATRIX.

## ◆ OpenExternalSearch()

void NetworkContentListWindow::OpenExternalSearch | ( |  | ) |
| inlineprivate

Search external websites for content.

Definition at line 353 of file network_content_gui.cpp.

References Textbuf::buf, content, ContentInfo::DOES_NOT_EXIST, FormatArrayAsHex(), Window::GetWidget(), ContentInfo::md5sum, ContentInfo::state, and ContentInfo::unique_id.

Referenced by OnClick().

## ◆ ScrollToSelected()

void NetworkContentListWindow::ScrollToSelected | ( |  | ) |
| inlineprivate

Make sure that the currently selected content info is within the visible part of the matrix.

Definition at line 527 of file network_content_gui.cpp.

References Scrollbar::ScrollTowards().

Referenced by BuildContentList(), OnClick(), and OnKeyPress().

## ◆ SortContentList()

void NetworkContentListWindow::SortContentList | ( |  | ) |
| inlineprivate

Sort the content list.

Definition at line 457 of file network_content_gui.cpp.

References find_index(), Window::GetWidget(), and GUIList< T, P, F >::Sort().

Referenced by BuildContentList(), NetworkContentListWindow(), and OnClick().

## ◆ StateSorter()

static bool NetworkContentListWindow::StateSorter | ( | const ContentInfo *const & | a,
|  | const ContentInfo *const & | b
| ) |  |
| inlinestaticprivate

Sort content by state.

Definition at line 449 of file network_content_gui.cpp.

References ContentInfo::state, and TypeSorter().

## ◆ TagNameFilter()

static bool NetworkContentListWindow::TagNameFilter | ( | const ContentInfo *const * | a,
|  | ContentListFilterData & | filter
| ) |  |
| inlinestaticprivate

Filter content by tags/name.

Definition at line 466 of file network_content_gui.cpp.

References StringFilter::AddLine(), ContentInfo::AUTOSELECTED, StringFilter::GetState(), StringFilter::ResetState(), ContentInfo::SELECTED, and ContentListFilterData::string_filter.

## ◆ TypeOrSelectedFilter()

static bool NetworkContentListWindow::TypeOrSelectedFilter | ( | const ContentInfo *const * | a,
|  | ContentListFilterData & | filter
| ) |  |
| inlinestaticprivate

Filter content by type, but still show content selected for download.

Definition at line 478 of file network_content_gui.cpp.

References ContentInfo::AUTOSELECTED, ContentInfo::SELECTED, and ContentListFilterData::types.

## ◆ TypeSorter()

static bool NetworkContentListWindow::TypeSorter | ( | const ContentInfo *const & | a,
|  | const ContentInfo *const & | b
| ) |  |
| inlinestaticprivate

Sort content by type.

Definition at line 438 of file network_content_gui.cpp.

References content_type_strs, NameSorter(), StrNaturalCompare(), and ContentInfo::type.

Referenced by StateSorter().

## ◆ UpdateFilterState()

bool NetworkContentListWindow::UpdateFilterState | ( |  | ) |
| inlineprivate

Update filter state based on current window state.

Returns
  true if filter state was changed, otherwise false.

Definition at line 516 of file network_content_gui.cpp.

References GUIList< T, P, F >::GetFiltering(), Window::GetWidget(), StringFilter::IsEmpty(), GUIList< T, P, F >::SetFilterState(), ContentListFilterData::string_filter, and ContentListFilterData::types.

Referenced by NetworkContentListWindow(), OnEditboxChanged(), and OnKeyPress().

## ◆ UpdateWidgetSize()

void NetworkContentListWindow::UpdateWidgetSize | ( | WidgetID | widget,
|  | Dimension & | size,
|  | const Dimension & | padding,
|  | Dimension & | fill,
|  | Dimension & | resize
| ) |  |
| inlineoverridevirtual

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters

  | widget | Widget number.
  [in,out] | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  [in,out] | fill | Fill step of the widget.
  [in,out] | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 587 of file network_content_gui.cpp.

References CONTENT_TYPE_BASE_GRAPHICS, CONTENT_TYPE_BEGIN, CONTENT_TYPE_END, FS_NORMAL, GetCharacterHeight(), GetStringBoundingBox(), Window::GetWidget(), maxdim(), Window::resize, WID_NCL_CHECKBOX, WID_NCL_MATRIX, and WID_NCL_TYPE.

## Friends And Related Symbol Documentation

## ◆ BuildContentTypeStringList

void BuildContentTypeStringList | ( |  | ) |
| friend

Build array of all strings corresponding to the content types.

Definition at line 1029 of file network_content_gui.cpp.

## Field Documentation

## ◆ auto_select

bool NetworkContentListWindow::auto_select
| private

Automatically select all content when the meta-data becomes available.

Definition at line 340 of file network_content_gui.cpp.

## ◆ checkbox_size

Dimension NetworkContentListWindow::checkbox_size
| private

Size of checkbox/"blot" sprite.

Definition at line 343 of file network_content_gui.cpp.

## ◆ content

GUIContentList NetworkContentListWindow::content
| private

List with content.

Definition at line 339 of file network_content_gui.cpp.

Referenced by OnInvalidateData(), and OpenExternalSearch().

## ◆ content_type_strs

std::string NetworkContentListWindow::content_type_strs
| staticprivate

Cached strings for all content types.

Definition at line 350 of file network_content_gui.cpp.

Referenced by TypeSorter().

## ◆ EDITBOX_MAX_SIZE

const uint NetworkContentListWindow::EDITBOX_MAX_SIZE = 50
| staticprivate

Maximum size of the editbox in characters.

Definition at line 333 of file network_content_gui.cpp.

## ◆ filesize_sum

uint NetworkContentListWindow::filesize_sum
| private

The sum of all selected file sizes.

Definition at line 347 of file network_content_gui.cpp.

## ◆ filter_data

ContentListFilterData NetworkContentListWindow::filter_data
| private

Filter for content list.

Definition at line 341 of file network_content_gui.cpp.

## ◆ filter_editbox

QueryString NetworkContentListWindow::filter_editbox
| private

Filter editbox;.

Definition at line 342 of file network_content_gui.cpp.

Referenced by NetworkContentListWindow().

## ◆ filter_funcs

const std::initializer_list< NetworkContentListWindow::GUIContentList::FilterFunction *const > NetworkContentListWindow::filter_funcs
| staticprivate

Initial value:
= {
&TagNameFilter,
&TypeOrSelectedFilter,
}
NetworkContentListWindow::TagNameFilter
static bool TagNameFilter(const ContentInfo *const *a, ContentListFilterData &filter)
Filter content by tags/name.
Definition network_content_gui.cpp:466
NetworkContentListWindow::TypeOrSelectedFilter
static bool TypeOrSelectedFilter(const ContentInfo *const *a, ContentListFilterData &filter)
Filter content by type, but still show content selected for download.
Definition network_content_gui.cpp:478

Filter functions.

Definition at line 1019 of file network_content_gui.cpp.

## ◆ last_filtering

Filtering NetworkContentListWindow::last_filtering = {false, 0}
| staticprivate

The last filtering setting.

Definition at line 1011 of file network_content_gui.cpp.

## ◆ last_sorting

Listing NetworkContentListWindow::last_sorting = {false, 1}
| staticprivate

The last sorting setting.

Definition at line 1010 of file network_content_gui.cpp.

## ◆ list_pos

int NetworkContentListWindow::list_pos
| private

Our position in the list.

Definition at line 346 of file network_content_gui.cpp.

Referenced by OnKeyPress().

## ◆ selected

const ContentInfo* NetworkContentListWindow::selected
| private

The selected content info.

Definition at line 345 of file network_content_gui.cpp.

## ◆ sorter_funcs

const std::initializer_list< NetworkContentListWindow::GUIContentList::SortFunction *const > NetworkContentListWindow::sorter_funcs
| staticprivate

Initial value:
= {
&StateSorter,
&TypeSorter,
&NameSorter,
}
NetworkContentListWindow::NameSorter
static bool NameSorter(const ContentInfo *const &a, const ContentInfo *const &b)
Sort content by name.
Definition network_content_gui.cpp:432
NetworkContentListWindow::TypeSorter
static bool TypeSorter(const ContentInfo *const &a, const ContentInfo *const &b)
Sort content by type.
Definition network_content_gui.cpp:438
NetworkContentListWindow::StateSorter
static bool StateSorter(const ContentInfo *const &a, const ContentInfo *const &b)
Sort content by state.
Definition network_content_gui.cpp:449

Sorter functions.

Definition at line 1013 of file network_content_gui.cpp.

## ◆ vscroll

Scrollbar* NetworkContentListWindow::vscroll
| private

Cache of the vertical scrollbar.

Definition at line 348 of file network_content_gui.cpp.

The documentation for this class was generated from the following file:

- src/network/network_content_gui.cpp